// Generated by CoffeeScript 2.5.0
var DISPLAY_JS, allCirruFiles, baseFolder, chalk, clipboardy, code, compiler, copy, filename, fromDir, fs, fullpath, getAllCirruFiles, instance, js, m, mainModule, maybeShowJs, path, repl, seperator, toDir, vm;

fs = require('fs');

path = require('path');

repl = require('repl');

vm = require('vm');

m = require('module');

chalk = require('chalk');

compiler = require('./compiler');

seperator = '-----------------';

DISPLAY_JS = process.env.DISPLAY_JS === 'true';

maybeShowJs = function(js, filename) {
  if (DISPLAY_JS) {
    return console.log(chalk.gray(js));
  }
};

getAllCirruFiles = function(x) {
  var children;
  if (fs.statSync(x).isFile()) {
    if (x.match(/\.cirru$/)) {
      return [x];
    } else {
      return [];
    }
  } else {
    children = fs.readdirSync(x);
    return children.flatMap(function(child) {
      var childPath;
      if (child === 'node_modules') {
        return [];
      } else {
        childPath = path.join(x, child);
        return getAllCirruFiles(childPath);
      }
    });
  }
};

if (process.argv[2] === 'compile') {
  fromDir = process.argv[3];
  toDir = process.argv[4];
  if ((fromDir == null) || (toDir == null)) {
    console.log("cirruscript compile {from dir} {to dir}");
    process.exit(1);
  }
  baseFolder = path.join(process.env.PWD, fromDir);
  allCirruFiles = getAllCirruFiles(baseFolder);
  allCirruFiles.forEach(function(x) {
    var code, js, relativeOne, toFilepath;
    code = fs.readFileSync(x, 'utf8');
    js = compiler.compile(code);
    relativeOne = path.relative(baseFolder, x);
    toFilepath = (path.join(process.env.PWD, toDir, relativeOne)).replace(/\.cirru$/, '.js');
    fs.mkdirSync(path.dirname(toFilepath), {
      recursive: true
    }, function(err) {
      return console.log(err);
    });
    fs.writeFileSync(toFilepath, js);
    return console.log(path.relative(process.env.PWD, x), '\t->\t', path.relative(process.env.PWD, toFilepath));
  });
} else if (process.argv[2] != null) {
  filename = process.argv[2];
  fullpath = path.join(process.env.PWD, filename);
  if (!fs.existsSync(fullpath)) {
    console.log("Found no file", fullpath);
    process.exit(1);
  }
  if (fs.statSync(fullpath).isDirectory()) {
    console.log(fullpath, "is a directory. No evaling.");
    process.exit(1);
  }
  require('./register');
  mainModule = require.main;
  mainModule.filename = filename = fs.realpathSync(filename);
  mainModule.moduleCache && (mainModule.moduleCache = {});
  mainModule.paths = m._nodeModulePaths(path.dirname(filename));
  code = fs.readFileSync(filename, 'utf8');
  js = compiler.compile(code);
  maybeShowJs(js);
  mainModule._compile(js, mainModule.filename);
} else {
  console.log();
  console.log(chalk.gray("  Welcome to CirruScript! ."));
  console.log(chalk.gray("  Find more at http://script.cirru.org ."));
  console.log(chalk.gray("  Press Command D when you want to exit."));
  console.log(chalk.gray("  Use DISPLAY_JS=true for displaying generated js."));
  console.log();
  clipboardy = require('clipboardy');
  copy = function(x) {
    var content;
    content = typeof x === 'string' ? x : JSON.stringify(x, null, 2);
    clipboardy.writeSync(content);
    return console.log(chalk.cyan(content));
  };
  instance = repl.start({
    prompt: chalk.bold('cirruscript> '),
    eval: function(input, context, filename, cb) {
      var err;
      code = input.slice(0, -1);
      try {
        js = compiler.compile(code);
        maybeShowJs(js, 'REPL');
        return cb(null, vm.runInContext(js, context));
      } catch (error) {
        err = error;
        return cb(err);
      }
    }
  });
  instance.context.console.copy = copy;
  instance.context.console.DISPLAY_JS = function(x) {
    return DISPLAY_JS = x;
  };
}
